Module Enums

    Public Enum KontaktKategorie As Short
        Familie
        Freund
        Bekannter
        Kollege
        Geschftspartner
        Kunde
        Lieferant
        ZuMeiden
        Firma
        AnsprechpartnerBeiFirmenKontakt
    End Enum

    Sub main()

        EnumFlags()

        Dim locKontakte As KontaktKategorie
        Dim locShort As Short

        locKontakte = KontaktKategorie.Geschftspartner

        'Typumwandlung von Aufzhlung zu zu Grunde liegenden Datentyp...
        locShort = locKontakte
        locShort = KontaktKategorie.Firma

        '...und umgekehrt, auch nicht schwieriger:
        locKontakte = CType(locShort, KontaktKategorie)

        Console.WriteLine(locKontakte)

        'Ermittelt den Namen des zu Grunde liegenden primitiven einer Aufzhlung 
        Console.WriteLine([Enum].GetUnderlyingType(GetType(KontaktKategorie)).Name)

        'Ermittelt den Typnamen anhand einer Aufzhlungsvariablen
        Console.WriteLine([Enum].GetUnderlyingType(locKontakte.GetType).Name)

        'Umwandlung in einen String
        Console.WriteLine(locKontakte.ToString())

        'Umwandlung zurck in ein Enum-Element aus einem String - schon anspruchsvoller!
        Dim locString As String = "Geschftspartner"
        locKontakte = DirectCast([Enum].Parse(GetType(KontaktKategorie), locString), KontaktKategorie)

        Console.ReadLine()

    End Sub

    Sub EnumFlags()

        Dim locKontakte As KontaktKategorien
        locKontakte = KontaktKategorien.Freund Or KontaktKategorien.Geschftspartner
        'Console.WriteLine(locKontakte)
        'Console.WriteLine(locKontakte.ToString())

        'Achtung bei Flags! Bits mssen ausmaskiert werden!
        'Diese Abfrage liefert das falsche Ergebnis!
        If locKontakte = KontaktKategorien.Geschftspartner Then
            Console.WriteLine("Du bist ein Geschftspartner")
        Else
            Console.WriteLine("Du bist kein Geschftspartner")
        End If


        'So ist's richtig; diese Abfrage liefert das richtige Ergebnis:
        If (locKontakte And KontaktKategorien.Freund) = KontaktKategorien.Freund Then
            Console.WriteLine("Du bist ein Freund")
        Else
            Console.WriteLine("Du bist kein Freund")
        End If

        'Und so funktionieren Kombiabfragen:
        If locKontakte = (KontaktKategorien.Freund Or KontaktKategorien.Geschftspartner) Then
            Console.WriteLine("Du bist ein Freund und ein Geschftspartner")
        End If

        Console.ReadLine()

    End Sub

End Module

<Flags()> _
Public Enum KontaktKategorien
    Keine = 0
    Familie = 1
    Freund = 2
    Bekannter = 4
    Kollege = 8
    Geschftspartner = 16
    Kunde = 32
    Lieferant = 64
    ZuMeiden = 128
    Firma = 256
    AnsprechpartnerBeiFirmenKontakt = 512
End Enum
