﻿Module LinqDemo

    Sub Main()

        Dim adrListe = Kontakt.ZufallsKontakte(10)
        Dim artListe = Artikel.Zufallsartikel(adrListe)

        Dim adrListeGruppiert = From adrElement In adrListe _
                                Join artElement In artListe _
                                On adrElement.ID Equals artElement.IDGekauftVon _
                                Select adrElement.ID, adrElement.Nachname, _
                                       adrElement.Vorname, adrElement.PLZ, _
                                       artElement.ArtikelNummer, artElement.ArtikelName, _
                                       artElement.Anzahl, artElement.Einzelpreis, _
                                       Postenpreis = artElement.Anzahl * artElement.Einzelpreis _
                                Order By Nachname, ArtikelNummer _
                                Where (PLZ > "0" And PLZ < "50000") _
                                Group ArtikelNummer, ArtikelName, _
                                      Anzahl, Einzelpreis, Postenpreis _
                                By ID, Nachname, Vorname _
                                Into Artikelliste = Group, AnzahlArtikel = Count(), _
                                     Gesamtpreis = Sum(Postenpreis)


        For Each KundenItem In adrListeGruppiert
            With KundenItem
                Console.WriteLine(.ID & ": " & .Nachname & ", " & .Vorname & " - " & .AnzahlArtikel & " Artikel zu insgesamt " & .Gesamtpreis & " Euro")
                Console.WriteLine("     Details:")
                For Each ArtItem In KundenItem.Artikelliste
                    With ArtItem
                        Console.WriteLine("     " & .ArtikelNummer & ": " & .ArtikelName & _
                                          "(" & .Anzahl & " Stück für insgesamt " _
                                          & (.Einzelpreis * .Anzahl).ToString("#,##0.00") & " Euro)")
                    End With
                Next
            End With

        Next
        Console.ReadKey()

    End Sub

End Module
