﻿Module LinqDemo

    Private adrListe As List(Of Kontakt) = Kontakt.ZufallsKontakte(100)
    Private artListe As List(Of Artikel) = Artikel.Zufallsartikel(adrListe)

    Sub Main()

        LINQAbfragenAufbau()
        'KombinierteKomplexeAbfrage()
        'SelectSpeedCompare()
        'SerialLinqsCompare()
        'Auflistungsvereinigung()
        'JoinDemo()
        'GroupByDemo()
        'GroupByJoinedCombined()
        'GroupJoin()
        'AggregateDemo()
        'JoinAggregateDemo()
        Console.ReadKey()

    End Sub

    Sub LINQAbfragenAufbau()

        Console.WriteLine("Ergebnisliste 1:")
        Console.WriteLine("----------------")

        Dim ergebnisListe = From adrElement In adrListe _
                            Order By adrElement.Nachname, adrElement.Vorname Descending _
                            Select KontaktId = adrElement.ID, _
                                   adrElement.Nachname, _
                                   adrElement.Vorname, _
                                   PlzOrtKombi = adrElement.PLZ & " " & adrElement.Ort _
                            Where KontaktId > 50 And KontaktId < 100 And _
                                    Nachname Like "L*"

        For Each ergebnisItem In ergebnisListe
            With ergebnisItem
                Console.WriteLine(.KontaktId & ": " & _
                                  .Nachname & ", " & .Vorname & _
                                  " - " & .PlzOrtKombi)
            End With
        Next

        Console.WriteLine()
        Console.WriteLine("Ergebnisliste 2:")
        Console.WriteLine("----------------")


        Dim ergebnisListe2 = From adrElement In adrListe _
                    Where adrElement.ID > 50 And adrElement.ID < 100 And _
                            adrElement.Nachname Like "L*" _
                    Select KontaktId = adrElement.ID, _
                           adrElement.Nachname, _
                           adrElement.Vorname, _
                           PlzOrtKombi = adrElement.PLZ & " " & adrElement.Ort _
                    Order By Nachname, Vorname

        For Each ergebnisItem In ergebnisListe2
            With ergebnisItem
                Console.WriteLine(.KontaktId & ": " & _
                                  .Nachname & ", " & .Vorname & _
                                  " - " & .PlzOrtKombi)
            End With
        Next
    End Sub

    Sub KombinierteKomplexeAbfrage()

        Dim adrListeGruppiert = From adrElement In adrListe _
                        Join artElement In artListe _
                        On adrElement.ID Equals artElement.IDGekauftVon _
                        Select adrElement.ID, adrElement.Nachname, _
                               adrElement.Vorname, adrElement.PLZ, _
                               artElement.ArtikelNummer, artElement.ArtikelName, _
                               artElement.Anzahl, artElement.Einzelpreis, _
                               Postenpreis = artElement.Anzahl * artElement.Einzelpreis _
                        Order By Nachname, ArtikelNummer _
                        Where (PLZ > "0" And PLZ < "50000") _
                        Group ArtikelNummer, ArtikelName, _
                              Anzahl, Einzelpreis, Postenpreis _
                        By ID, Nachname, Vorname _
                        Into Artikelliste = Group, AnzahlArtikel = Count(), _
                             Gesamtpreis = Sum(Postenpreis) _
                        Where Gesamtpreis > 1000


        For Each KundenItem In adrListeGruppiert
            With KundenItem
                Console.WriteLine(.ID & ": " & .Nachname & ", " & .Vorname & " - " & .AnzahlArtikel & " Artikel zu insgesamt " & .Gesamtpreis & " Euro")
                Console.WriteLine("     Details:")
                For Each ArtItem In KundenItem.Artikelliste
                    With ArtItem
                        Console.WriteLine("     " & .ArtikelNummer & ": " & .ArtikelName & _
                                          "(" & .Anzahl & " Stück für insgesamt " _
                                          & (.Einzelpreis * .Anzahl).ToString("#,##0.00") & " Euro)")
                    End With
                Next
            End With

        Next
        Console.ReadKey()
    End Sub

    Sub SelectSpeedCompare()

        Dim hsp As New HighSpeedTimeGauge
        Console.WriteLine("Starte Test")
        hsp.Start()
        Dim ergebnisListe = From adrElement In adrListe _
                            Order By adrElement.Nachname, adrElement.Vorname _
                            Select KontaktId = adrElement.ID, _
                                   adrElement.Nachname, _
                                   adrElement.Vorname, _
                                   PlzOrtKombi = adrElement.PLZ & " " & adrElement.Ort

        Dim ersteAnzahl = ergebnisListe.Count
        hsp.Stop()
        Dim dauer1 = hsp.DurationInMilliSeconds

        hsp.Reset()
        hsp.Start()
        Dim ergebnisListe2 = From adrElement In adrListe _
                            Order By adrElement.Nachname, adrElement.Vorname

        Dim zweiteAnzahl = ergebnisListe2.Count
        hsp.Stop()
        Dim dauer2 = hsp.DurationInMilliSeconds

        Console.WriteLine("Abfragedauer mit Select: " & dauer1 & " für " & ersteAnzahl & " Ergebniselemente.")
        Console.WriteLine("Abfragedauer ohne Select: " & dauer2 & " für " & zweiteAnzahl & " Ergebniselemente.")
    End Sub

    Sub SerialLinqsCompare()

        Dim hsp As New HighSpeedTimeGauge
        Console.WriteLine("Starte Test")
        hsp.Start()
        Dim ergebnisListe = From adrElement In adrListe _
                            Order By adrElement.Nachname, adrElement.Vorname

        Dim ergebnisListe2 = From adrElement In ergebnisListe _
                            Where adrElement.Nachname Like "L*"

        ergebnisListe2 = From adrElement In ergebnisListe2 _
                            Where adrElement.ID > 50 And adrElement.ID < 200

        Dim ersteAnzahl = ergebnisListe2.Count
        hsp.Stop()
        Dim dauer1 = hsp.DurationInMilliSeconds

        hsp.Reset()
        hsp.Start()
        Dim ergebnisListe3 = From adrElement In adrListe _
                            Order By adrElement.Nachname, adrElement.Vorname _
                            Where adrElement.Nachname Like "L*" And _
                            adrElement.ID > 50 And adrElement.ID < 200
        Dim zweiteAnzahl = ergebnisListe3.Count
        zweiteAnzahl = ergebnisListe3.Count
        hsp.Stop()
        Dim dauer2 = hsp.DurationInMilliSeconds

        Console.WriteLine("Abfragedauer serielle Abfrage: " & dauer1 & " für " & ersteAnzahl & " Ergebniselemente.")
        Console.WriteLine("Abfragedauer kombinierte Abfrage: " & dauer2 & " für " & zweiteAnzahl & " Ergebniselemente.")

        adrListe.Add(New Kontakt(51, "Löffelmann", "Klaus", "Wiedenbrücker Straße 47", "59555", "Lippstadt"))
        Console.WriteLine("Elemente der seriellen Abfrage: " & ergebnisListe2.Count)

        Dim reineGenerischeListe = ergebnisListe.ToLookup(Function(einKontakt) einKontakt.ID)
    End Sub

    Sub Auflistungsvereinigung()

        Dim ergebnisliste = From adrElement In adrListe, artElement In artListe
        'Where adrElement.ID = artElement.IDGekauftVon

        For Each element In ergebnisliste
            With element
                Console.WriteLine(.adrElement.ID & ": " & .adrElement.Nachname & _
                                  ", " & .adrElement.Vorname & ": " & _
                                  .artElement.IDGekauftVon & ": " & .artElement.ArtikelName)
            End With
        Next
    End Sub

    Sub JoinDemo()
        Dim ergebnisliste = From adrElement In adrListe _
                            Join artElement In artListe _
                            On adrElement.ID Equals artElement.IDGekauftVon

        For Each element In ergebnisliste
            With element
                Console.WriteLine(.adrElement.ID & ": " & .adrElement.Nachname & _
                                  ", " & .adrElement.Vorname & ": " & _
                                  .artElement.IDGekauftVon & ": " & .artElement.ArtikelName)
            End With
        Next
    End Sub

    Sub GroupByDemo()
        Dim ergebnisliste = From adrElement In adrListe _
                            Group By adrElement.Nachname Into Kontaktliste = Group _
                            Order By Nachname

        For Each element In ergebnisliste
            With element
                Console.WriteLine(element.Nachname)
                For Each Kontakt In element.Kontaktliste
                    With Kontakt
                        Console.WriteLine(.ID & ": " & .Nachname & ", " & .Vorname)
                    End With
                Next
                Console.WriteLine()
            End With
        Next
    End Sub

    Sub GroupByJoinedCombined()
        Dim ergebnisliste = From adrElement In adrListe _
                            Join artElement In artListe _
                            On adrElement.ID Equals artElement.IDGekauftVon _
                            Group artElement.IDGekauftVon, Artikelnummer = artElement.ArtikelNummer, _
                                artElement.ArtikelName _
                            By artElement.IDGekauftVon, adrElement.Nachname, adrElement.Vorname _
                            Into Artikelliste = Group, AnzahlArtikel = Count() Order By Nachname

        For Each kontaktElement In ergebnisliste
            With kontaktElement

                Console.WriteLine(.IDGekauftVon & ": " & .Nachname & ", " & .Vorname)
                For Each Artikel In .Artikelliste
                    With Artikel
                        Console.WriteLine("   " & .Artikelnummer & ": " & .ArtikelName)
                    End With
                Next
                Console.WriteLine()
            End With
        Next
    End Sub

    Sub GroupJoin()
        Dim ergebnisliste = From adrElement In adrListe _
                            Group Join artElement In artListe _
                            On adrElement.ID Equals artElement.IDGekauftVon Into Artikelliste = Group

        For Each kontaktElement In ergebnisliste
            With kontaktElement

                Console.WriteLine(.adrElement.ID & ": " & _
                                  .adrElement.Nachname & ", " _
                                  & .adrElement.Vorname)
                For Each Artikel In .Artikelliste
                    With Artikel
                        Console.WriteLine("   " & .ArtikelNummer & ": " & .ArtikelName)
                    End With
                Next
                Console.WriteLine()
            End With
        Next
    End Sub

    Sub AggregateDemo()

        Dim scheinbarerUmsatz = Aggregate artElement In artListe _
                           Into Summe = Sum(artElement.Einzelpreis)
        Console.WriteLine("Scheinbar beträgt der Umsatz {0:#,##0.00} Euro", scheinbarerUmsatz)

        Console.ReadKey()
        Console.Clear()

        Dim gesamtUmsatz = Aggregate artElement In artListe _
                           Let Artikelumsatz = artElement.Einzelpreis * artElement.Anzahl _
                           Into Summe = Sum(Artikelumsatz)
        Console.WriteLine("Der Umsatz beträgt {0:#,##0.00} Euro", gesamtUmsatz)
        Console.ReadKey()
        Console.Clear()

        Dim mehrereInfos = Aggregate artElement In artListe _
                           Let Artikelumsatz = artElement.Einzelpreis * artElement.Anzahl _
                           Into Summe = Sum(Artikelumsatz), _
                                        Minimalpreis = Min(artElement.Einzelpreis), _
                                        MaximalPreis = Max(artElement.Einzelpreis)
        Console.WriteLine("Der Umsatz beträgt {0:#,##0.00} Euro" & vbNewLine & _
                          "Minimal- und Maximalpreis jeweils " & _
                          "{1:#,##0.00} und {2:#,##0.00} Euro", _
                          mehrereInfos.Summe, mehrereInfos.Minimalpreis, _
                         mehrereInfos.MaximalPreis)

    End Sub

    Sub JoinAggregateDemo()
        Dim ergebnisListe = From adrElement In adrListe _
                            Group Join artElement In artListe _
                            On adrElement.ID Equals artElement.IDGekauftVon _
                            Into JoinedList = Group, _
                            KundenUmsatz = Sum(artElement.Einzelpreis * artElement.Anzahl) _
                            Order By KundenUmsatz Descending _
                            Take 10

        For Each item In ergebnisListe
            With item.adrElement
                Console.WriteLine(.ID & ": " & .Nachname & ", " _
                                  & .Vorname & " --- Umsatz:" _
                                  & item.KundenUmsatz.ToString("#,##0.00") & _
                                  " Euro")
            End With
        Next
    End Sub

End Module
