﻿Imports System.Xml.Linq
Imports System.Xml
Imports System.Linq

Imports <xmlns="http://mysample.local.de/fuhrpark2">

Public Class XMLmitLINQabfragen_Intellisense

    ''' <summary>
    ''' Beispiel: Designer Untersützung für XML (Intellisense)
    ''' XML mit LINQ Abfragen
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        MyBase.OnLoad(e)

        ' XML Element festlegen
        Dim fuhrpark = <?xml version="1.0"?>
                       <fuhrpark>
                           <fahrzeug>
                               <kennzeichen>MS-VB 2008</kennzeichen>
                               <hersteller>MAN</hersteller>
                               <ladung menge="10000">Salz</ladung>
                           </fahrzeug>
                           <fahrzeug>
                               <kennzeichen>MS-C# 2008</kennzeichen>
                               <hersteller>Mercedes-Benz</hersteller>
                               <ladung menge="20000">Erdnüsse</ladung>
                           </fahrzeug>
                           <fahrzeug>
                               <kennzeichen>MS-J# 2008</kennzeichen>
                               <hersteller>DAF</hersteller>
                               <ladung menge="5000">Wackeldackel</ladung>
                           </fahrzeug>
                       </fuhrpark>

        ' Alle MAN-Fahrzeuge mit LINQ ermitteln
        ' d.h. Werte eines Elements überprüfen
        Dim manFahrzeuge = From fahrzeug In fuhrpark...<fahrzeug> _
                           Where fahrzeug.<hersteller>.Value = "MAN"
        For Each fahrzeug In manFahrzeuge
            Console.WriteLine(fahrzeug)
        Next

        ' Alle Fahrzeuge mit einer Ladung > 15000 ermitteln
        ' d.h. Attributwerte überprüfen
        Dim schwerBeladen = From fahrzeug In fuhrpark...<fahrzeug> _
                            Where fahrzeug.<ladung>.@menge > 15000

        Console.WriteLine("Schwer beladen")
        For Each fahrzeug In schwerBeladen
            Console.WriteLine(fahrzeug)
        Next

    End Sub

End Class