﻿Imports System.Data.Linq

Module DynamischeAbfragen

    Sub main()

        Dim datacontext As New AdventureWorksDataContext

        Dim ladeOptionen = New DataLoadOptions
        ladeOptionen.LoadWith(Of Vendor)(Function(v) v.ProductVendors)
        ladeOptionen.LoadWith(Of ProductVendor)(Function(p) p.Product)
        datacontext.LoadOptions = ladeOptionen

        'Und Debug-Ausgaben
        datacontext.Log = Console.Out

        Dim whereList As String() = {"Name.StartsWith(""H"")"}
        Dim OrderByList As String() = {"Name"}

        Dim LieferantenListe = DynamicWhereAndOrderQuery(Of Vendor, Table(Of Vendor))(datacontext.Vendors, whereList, OrderByList)

        'Rausfinden: Welche Produkte liefert der Lieferant
        For Each Lieferant In LieferantenListe
            Console.WriteLine(Lieferant.AccountNumber & ": " & Lieferant.Name)
            Console.WriteLine(New String("="c, 70))
            For Each produkt In Lieferant.ProductVendors
                Console.Write("ID:" & produkt.ProductID & " ")
                Console.WriteLine("Name:" & produkt.Product.Name)
            Next
            Console.WriteLine()

        Next
        Console.ReadLine()
    End Sub

    Public Function DynamicWhereAndOrderQuery(Of baseQueryType, baseQueryListType As IQueryable(Of baseQueryType)) _
                (ByVal queryObject As baseQueryListType, _
                 ByVal WhereList As IEnumerable(Of String), _
                 ByVal OrderByList As IEnumerable(Of String)) As IQueryable(Of baseQueryType)

        'Where-String zusammenbauen
        Dim whereString = ""
        For c = 0 To WhereList.Count - 1
            whereString &= WhereList(c)
            If c < WhereList.Count - 1 Then
                whereString &= " AND "
            End If
        Next

        'OrderBy-String zusammenbauen
        Dim orderString = ""
        For c = 0 To OrderByList.Count - 1
            orderString &= OrderByList(c)
            If c < OrderByList.Count - 1 Then
                whereString &= ", "
            End If
        Next

        Return queryObject.Where(whereString).OrderBy(orderString)

    End Function

End Module

