﻿Imports System.Data.Linq

Module EagerLazyLoading

    Sub main()

        Dim verzögertesLaden = True

        ' Neuen DataContext anlegen
        Dim dataContext As New AdventureWorksDataContext
        Console.Write("Produktliste zu jedem Lieferanten immer direkt laden? [J/N]")
        If Console.ReadLine.ToLower = "j" Then
            verzögertesLaden = False
        End If

        'Alle Datenbank Aktionen auf Console.Out ausgeben
        dataContext.Log = Console.Out

        If Not verzögertesLaden Then
            Dim ladeOptionen = New DataLoadOptions
            ladeOptionen.LoadWith(Of Vendor)(Function(v) v.ProductVendors)
            ladeOptionen.LoadWith(Of ProductVendor)(Function(p) p.Product)
            dataContext.LoadOptions = ladeOptionen
        End If

        Dim LieferantenListe = From lieferantItem In dataContext.Vendors _
                               Where lieferantItem.Name.StartsWith("H") _
                               Order By lieferantItem.Name

        'Rausfinden: Welche Produkte liefert der Lieferant
        For Each Lieferant In LieferantenListe
            Console.WriteLine(Lieferant.AccountNumber & ": " & Lieferant.Name)
            Console.WriteLine(New String("="c, 70))
            For Each produkt In Lieferant.ProductVendors
                Console.Write("ID:" & produkt.ProductID & " ")
                Console.WriteLine("Name:" & produkt.Product.Name)
            Next
            Console.WriteLine()

        Next

        Console.WriteLine()
        Console.WriteLine("Taste drücken, zum Beenden")
        Console.ReadKey()
    End Sub

End Module
