﻿Module JoinAnonym

    ''' <summary>
    ''' Beispiel: Abfragen von Daten mit Hilfe eines Joins
    ''' Das Ergebnis wird in anonymen Typen gespeichert
    ''' </summary>
    ''' <remarks></remarks>
    Sub Main()
        Dim datacontext As New AdventureWorksDataContext

        Dim LieferantenAdressen = From adr In datacontext.Addresses _
                        Join lieferantenAdressItem In datacontext.VendorAddresses _
                        On adr.AddressID Equals lieferantenAdressItem.AddressID _
                        Join lieferantItem In datacontext.Vendors _
                        On lieferantItem.VendorID Equals lieferantenAdressItem.VendorID _
                        Where lieferantItem.Name.StartsWith("H") _
                        Select New With {.KontoNr = lieferantItem.AccountNumber, _
                                         .Lieferantename = lieferantItem.Name, _
                                         .Adresszeile1 = lieferantenAdressItem.Address.AddressLine1, _
                                         .Adresszeile2 = lieferantenAdressItem.Address.AddressLine2, _
                                         .PLZ = lieferantenAdressItem.Address.PostalCode, _
                                         .Ort = lieferantenAdressItem.Address.City}

        'Möchten Sie wissen, welche T-SQL-Kommandos generiert werden?
        'Einfach die Zeilen auskommentieren!
        'Console.WriteLine()
        'datacontext.Log = Console.Out

        For Each Lieferant In LieferantenAdressen
            Console.WriteLine("Konto: {0}; Name: {1}; Ort {2} {3} {4} {5}", _
                               Lieferant.KontoNr, _
                               Lieferant.Lieferantename, _
                               Lieferant.Adresszeile1, _
                               Lieferant.Adresszeile2, _
                               Lieferant.PLZ, _
                               Lieferant.Ort)
        Next
        Console.WriteLine()
        Console.WriteLine("Taste drücken, zum Beenden")
        Console.ReadKey()
    End Sub

End Module
