﻿Module KaskadierteAbfragen

    ''' <summary>
    ''' Beispiel: Zusammenstellen einer Abfrage aus mehreren Abfragen
    ''' </summary>
    ''' <remarks></remarks>
    Sub main()

        Dim GesuchterLieferant = "Hybrid Bicycle Center"

        Dim datacontext As New AdventureWorksDataContext

        ' Abfrage für Lieferant erstellen
        Dim lieferant = From lieferantItem In datacontext.Vendors _
                   Where lieferantItem.Name = GesuchterLieferant

        ' Abfrage für Lieferantenadresse erstellen
        Dim lieferantAdressZuordnung = From zuordnungItem In datacontext.VendorAddresses _
                           Where lieferant.All(Function(c) c.VendorID = zuordnungItem.VendorID)

        ' Wichtig: Wir könnten natürlich auch die Where-Klausel auch formulieren als
        '          ... WHERE lieferant(0).VendorID=zuordnungsItem.VendorID
        'doch dann griffen wir auf ein Element (das einzige!) der ersten Ergebnisauflistung zurück,
        'und würden dort bereits die Abfrage ausführen und die Kaskade unterbrechen.


        ' Abfrage für Adresse erstellen
        Dim lieferantAdresse = From adressItem In datacontext.Addresses _
                  Where lieferantAdressZuordnung.All(Function(a) a.AddressID = adressItem.AddressID)

        'Alle Datenbank Aktionen auf Console.Out ausgeben
        datacontext.Log = Console.Out

        ' Abfrage ausführen (und Objekt vom Datenkontext trennen!)
        Dim adressListe = lieferantAdresse.ToList

        ' Gefundene Datensäze ausgeben
        For Each adressItem In adressListe
            Console.WriteLine("Adresse von {0}: {1} {2} {3}", GesuchterLieferant, _
                              adressItem.AddressLine1, _
                              adressItem.PostalCode, _
                              adressItem.City)
        Next

        Console.WriteLine()
        Console.WriteLine("Taste drücken, zum Beenden")
        Console.ReadKey()
    End Sub


End Module
