﻿Module Transaktion

    Sub main()
        Dim datacontext As New AdventureWorksDataContext
        datacontext.Log = Console.Out

        ' neuen Transaktionsgültigkeitsbereich anlegen
        Dim ts As New Transactions.TransactionScope
        Using ts
            ' CreditRating einlesen, ändern und speichern
            Dim electronicBikeRepair = (From lieferant In datacontext.Vendors _
                                      Where lieferant.Name = "Electronic Bike Repair & Supplies").First
            electronicBikeRepair.CreditRating = 1
            datacontext.SubmitChanges()

            ' den Transaktionsgültigkeitsbereich beenden
            ' also das Commit absetzen.
            ts.Complete()
            Console.WriteLine("Die Änderungen wurden gespeichert. Bitte Return drücken, um Programm zu beenden.")
            Console.ReadKey()
        End Using
    End Sub

    Sub main_ADO()
        Dim datacontext As New AdventureWorksDataContext
        datacontext.Connection.Open()
        datacontext.Transaction = datacontext.Connection.BeginTransaction()
        datacontext.Log = Console.Out
        Try

            ' CreditRating einlesen, ändern und speichern
            Dim electronicBikeRepair = (From lieferant In datacontext.Vendors _
                                      Where lieferant.Name = "Electronic Bike Repair & Supplies").First
            electronicBikeRepair.CreditRating = 1
            datacontext.SubmitChanges()

            datacontext.Transaction.Commit()
            Console.WriteLine("Die Änderungen wurden gespeichert. Bitte Return drücken, um Programm zu beenden.")
            Console.ReadKey()
        Catch ex As Exception
            datacontext.Transaction.Rollback()
        Finally
            datacontext.Transaction = Nothing
        End Try
    End Sub

End Module
