﻿Imports System.Data.Objects

Module DatenBearbeiten

    Sub main()

        DatenÄndern()
        'DatenVerknüpftEinfügen()
        'DatenLöschen()

    End Sub

    Sub DatenÄndern()

        Dim awContext As New AWEntities()

        Dim lieferant = (From lieferantItem In awContext.Vendors _
                          Where lieferantItem.Name.ToLower.StartsWith("hybrid") _
                          Order By lieferantItem.Name).First

        'Hin- und her ändern, damit es nicht nur einmal funktioniert:
        If lieferant.Name = "Hybrid Bicycle Center" Then
            lieferant.Name = "Hybrid Fahrad Center"
        Else
            lieferant.Name = "Hybrid Bicycle Center"
        End If

        Try
            Dim anzahl = awContext.SaveChanges()
            Console.WriteLine("Keine Konflikte bei der Speicherung. " _
                              & anzahl & " Aktualisierungen gespeichert.")

        Catch ex As OptimisticConcurrencyException
            awContext.Refresh(RefreshMode.ClientWins, lieferant)

            awContext.SaveChanges()
            Console.WriteLine("Konfliktfehler wurde abgefangen, Änderungen wurden gespeichert!")
        End Try

        'Änderungen zurückschreiben
        awContext.SaveChanges()

        Console.WriteLine()
        Console.WriteLine("Taste drücken, zum Beenden")
        Console.ReadKey()

    End Sub

    Sub DatenVerknüpftEinfügen()

        Dim awContext As New AWEntities()

        Dim neuerLieferant As New Vendor With {.Name = "ActiveDevelop", .CreditRating = 1, _
                                       .AccountNumber = "ACTDEV00001", .ModifiedDate = Now}


        'Das neue Produkt erstellen
        Dim neuesProdukt As New Product With {.Name = "Visual Basic 2008 - Das Entwicklerbuch", _
                                              .ProductNumber = "", _
                                              .ListPrice = 59, _
                                              .ModifiedDate = Now, _
                                              .DiscontinuedDate = #12/31/2011#, _
                                              .SellStartDate = #12/10/2008#, _
                                              .SellEndDate = #12/31/2011#, _
                                              .SafetyStockLevel = 5, _
                                              .ReorderPoint = 2}

        'Neues Lieferantenprodukt erstellen, das Produkt mit diesem,
        'und dieses mit dem Lieferanten verknüpfen

        Dim neuesLieferantenProdukt = New ProductVendor With {.Product = neuesProdukt, _
                                                .StandardPrice = 59, _
                                                .ModifiedDate = Now, _
                                                .UnitMeasureCode = "PC", _
                                                .AverageLeadTime = 19, _
                                                .MinOrderQty = 1, _
                                                .MaxOrderQty = 10}

        awContext.AddToVendors(neuerLieferant)
        neuerLieferant.ProductVendor.Add(neuesLieferantenProdukt)
        awContext.SaveChanges()

    End Sub

    Sub DatenLöschen()

        Dim awContext As New AWEntities()

        'Die Entitätsobjekte ermitteln, die sich durch das angegebene Produkt ergeben:
        Dim lieferantProduct = (From lieferantProduktItem In awContext.ProductVendor _
                                 From productItem In awContext.Product _
                                  Where productItem.ProductID = lieferantProduktItem.ProductID _
                                  Where productItem.Name = "Visual Basic 2008 - Das Entwicklerbuch" _
                                   Select lieferantProduktItem).First

        'Nur zur Kontrolle
        Console.WriteLine(lieferantProduct.ProductID)

        'Lazy-Loading: Die übergeordneten Entitätsobjekte laden.
        'Zuerst das Lieferantenprodukt, dass dem ermittelten Produkt
        'zugeordnet ist.
        lieferantProduct.ProductReference.Load()

        'Und genau so einfach laden wir auch den übergeordneten Lieferanten.
        lieferantProduct.VendorReference.Load()

        'Die Referenzen auf die Entitäten müssen wir uns
        'temporär merken, weil DeleteObject sie mit
        'der übergeordneten Tabelle zerstört.
        Dim tmpProduct = lieferantProduct.Product
        Dim tmpVendor = lieferantProduct.Vendor

        'Reihenfolge des Löschens spielt jetzt ...
        awContext.DeleteObject(tmpVendor)

        '... keine Rolle mehr.
        awContext.DeleteObject(tmpProduct)

        'Das Entity Framework legt die richtige Reihenfolge fest!
        awContext.SaveChanges()

    End Sub

End Module
