﻿Imports System.Reflection

Public Class Kontakt
    Private myID As Integer
    Private myVorname As String
    Private myNachname As String
    Private myOrt As String

    Public Property ID() As Integer
        Get
            Return myID
        End Get
        Set(ByVal value As Integer)
            myID = value
        End Set
    End Property

    Public Property Vorname() As String
        Get
            Return myVorname
        End Get
        Set(ByVal value As String)
            myVorname = value
        End Set
    End Property

    Public Property Nachname() As String
        Get
            Return myNachname
        End Get
        Set(ByVal value As String)
            myNachname = value
        End Set
    End Property

    Public Property Ort() As String
        Get
            Return MyOrt
        End Get
        Set(ByVal value As String)
            myOrt = value
        End Set
    End Property
End Class


Module Module1

    Private ziffern As Integer() = New Integer() {9, 1, 4, 2, 5, 8, 6, 7, 3, 0}
    Private ziffernNamen As String() = New String() {"null", "eins", "zwei", "drei", _
                                                    "vier", "fünf", "sechs", "sieben", _
                                                    "acht", "neun"}

    Private Namen As String() = New String() {"Jürgen", "Denise", "Angela", "Gaby", _
                                              "Andreas", "Katrin", "Klaus", "Arnold", _
                                              "Kerstin", "Anja", "Miriam", "Uta", "Momo", _
                                              "Leonie-Gundula"}

    Private Kontakte() As Kontakt = New Kontakt() { _
             New Kontakt With {.ID = 1, .Vorname = "Jürgen", .Nachname = "Heckhuis", .Ort = "Demohausen"}, _
             New Kontakt With {.ID = 2, .Vorname = "Ruprecht", .Nachname = "Dröge", .Ort = "Lippstadt"}, _
             New Kontakt With {.ID = 3, .Vorname = "Klaus", .Nachname = "Löffelmann", .Ort = "Demohausen"}, _
             New Kontakt With {.ID = 4, .Vorname = "Andreas", .Nachname = "Belke", .Ort = "Lippstadt"}, _
             New Kontakt With {.ID = 5, .Vorname = "Kerstin", .Nachname = "Lehnert", .Ort = "Ratingen"}, _
             New Kontakt With {.ID = 6, .Vorname = "Denise", .Nachname = "Wagner", .Ort = "Demohausen"}, _
             New Kontakt With {.ID = 7, .Vorname = "Anja", .Nachname = "Vielstedde", .Ort = "Lippstadt"}, _
             New Kontakt With {.ID = 8, .Vorname = "Angela", .Nachname = "Wördehoff", .Ort = "Demohausen"}, _
             New Kontakt With {.ID = 9, .Vorname = "Momo", .Nachname = "Weichel", .Ort = "Ratingen"}, _
             New Kontakt With {.ID = 10, .Vorname = "Leonie-Gundula", .Nachname = "Beckmann", .Ort = "Ratingen"}, _
             New Kontakt With {.ID = 11, .Vorname = "Miriam", .Nachname = "Sonntag", .Ort = "Lippstadt"} _
    }

    Sub Main()

        WhereBeispiel()
        'SelectBeispiel()
        'SelectBeispielAnonym()
        'ItemNumbererDemo()
        'OrderBy("Nachname")
        'GroupBy()
        'KombinierteErweiterungsmethoden()
        'KombinierteErweiterungsmethoden_á_la_LINQ()
        Console.ReadKey()

    End Sub

    Public Sub WhereBeispiel()
        ' Where iteriert durch alle Elemente der angegebenen 
        ' Auflistung und führt für jedes Element die Prüfung in der Lambda-Funktion
        ' durch. Trifft sie zu, wird das entsprechende Element
        ' in die neue Auflistung überführt.
        ' Hier der erste Versuch mit Integer-Elementen ...
        Dim fnums = ziffern.Where(Function(einIntElement) einIntElement < 6)

        Console.WriteLine("Ziffern < 6")
        For Each intElement In fnums
            Console.WriteLine(intElement)
        Next
        Console.WriteLine("-----------------")

        ' ... und hier ein weiterer mit Strings.
        Dim fStrings = Namen.Where(Function(einName) einName.StartsWith("K"c))
        Console.WriteLine("Namen die mit 'K' beginnen")
        For Each strElement In fStrings
            Console.WriteLine(strElement)
        Next
    End Sub

    Public Sub SelectBeispiel()
        ' Hier wird Select verwendet, um ein Element auf Grund seiner 
        ' Wertigkeit durch ein zweiten in einer anderen Auflistung zu ersetzen
        Dim ziffernListe = ziffern.Select(Function(einIntElement) ziffernNamen(einIntElement))

        Console.WriteLine("Ziffern:")
        For Each s As String In ziffernListe
            Console.WriteLine(s)
        Next
    End Sub

    Public Sub AnonymeKlasseDemo()

        Dim element = New With {.Elementname = "Ein Element", _
                                .ElementID = 42}

        Dim liste = ListeMitEinemElement(New With {.ID = 42, .Elementname = "Adams"})
    End Sub

    Public Function ListeMitEinemElement(Of TSource)(ByVal dasEineElement As TSource) As List(Of TSource)
        Dim lst As New List(Of TSource)
        lst.Add(dasEineElement)
        Return lst
    End Function

    Public Sub SelectBeispielAnonym()
        ' Hier wird Select verwendet, um ein Element auf Grund seiner 
        ' Wertigkeit durch ein zweiten in einer anderen Auflistung zu ersetzen
        Dim anonymeListe = ziffern.Select(Function(einIntElement) _
                                              New With {.OriginalWert = einIntElement, _
                                                        .Ziffernname = ziffernNamen(einIntElement)})
        Console.WriteLine("Ziffern:")
        For Each anonymerTyp In anonymeListe
            Console.WriteLine(anonymerTyp.OriginalWert & ", " & anonymerTyp.Ziffernname)
        Next
    End Sub

    Public Sub ItemNumbererDemo()
        Dim numList = ItemNumberer(New String() {"eins", "zwei", "drei", "vier", "fünf", _
                                             "sechs", "sieben", "acht", "neuen", "zehn"}, _
                                       Function(element, count) New With {.ID = count, _
                                                              .Element = element})

        For Each numListItem In numList
            Console.WriteLine(numListItem.ID & ": " & numListItem.Element)
        Next

    End Sub

    Public Function ItemNumberer(Of TSource, TResult)(ByVal source As IEnumerable(Of TSource), _
                        ByVal selector As Func(Of TSource, Integer, TResult)) As IEnumerable(Of TResult)

        Dim retColl As New List(Of TResult)
        Dim count = 1
        For Each item In source
            retColl.Add(selector(item, count))
            count += 1
        Next
        Return retColl.AsEnumerable
    End Function

    Public Sub OrderBy()
        'Für jedes Element liefert OrderBy das Sortierelement - bei einer Liste
        'von Strings ist das jedes Element selbst.
        Dim sortierteNamen = Namen.OrderBy(Function(einName) einName)

        For Each s In sortierteNamen
            Console.WriteLine(s)
        Next

        'Bei Klasseninstanzen liefert OrderBy die Instanz zum Sortieren,
        'und hier bestimmt die Eigenschaft, nach was sortiert wird.
        Dim sortierteKontakte = Kontakte.OrderBy(Function(einKontakt) einKontakt.Nachname)

        For Each kontaktElement In sortierteKontakte
            Console.WriteLine(kontaktElement.ID & ": " & _
                              kontaktElement.Nachname & ", " & _
                              kontaktElement.Vorname & ", " & _
                              kontaktElement.Ort)
        Next
    End Sub

    Public Sub OrderBy(ByVal PropertyName As String)
        'Wenn die "Sortierspalte" frei wählbar sein soll, kann
        'das jeweilige Elemente nur über Reflection ermittelt werden:
        Dim sortierteNamen = Kontakte.OrderBy(Function(einKontakt) _
                einKontakt.GetType.GetProperty(PropertyName).GetValue(einKontakt, Nothing))

        'Funktioniert aber auch!
        For Each kontaktElement In sortierteNamen
            Console.WriteLine(kontaktElement.ID & ": " & _
                              kontaktElement.Nachname & ", " & _
                              kontaktElement.Vorname & ", " & _
                              kontaktElement.Ort)
        Next
    End Sub

    Public Sub GroupBy()
        Dim gruppierteNamen = Kontakte.GroupBy(Function(einKontakt) einKontakt.Ort)

        For Each gruppenElement In gruppierteNamen
            Console.WriteLine(gruppenElement.Key)
            For Each kontaktElement In gruppenElement
                Console.WriteLine("---> " & kontaktElement.Nachname & ", " & kontaktElement.Vorname)
            Next
        Next

        Dim gruppierteKontakte = Kontakte.GroupBy(Function(einKontakt) _
                                                      einKontakt.Ort).Select(Function(eineGruppe) _
                                                        New With {.Ort = eineGruppe.Key, _
                                                        .Anzahl = eineGruppe.Count, _
                                                        .Elemente = eineGruppe.ToList})

        For Each gruppenElement In gruppierteKontakte
            Console.WriteLine(gruppenElement.Ort & " (Anzahl: " & gruppenElement.Anzahl & ")")
            For Each kontaktElement In gruppenElement.Elemente
                Console.WriteLine("---> " & kontaktElement.Nachname & ", " & kontaktElement.Vorname)
            Next
        Next

    End Sub

    Public Sub KombinierteErweiterungsmethoden()

        Dim ergebnisListe = Kontakte.Where(Function(einKontakt) einKontakt.Ort = "Lippstadt" _
                                             ).Select(Function(einKontakt) _
                                              New With {.ID = einKontakt.ID, _
                                                        .LastName = einKontakt.Nachname, _
                                                        .FirstName = einKontakt.Vorname, _
                                                        .City = einKontakt.Ort} _
                                                        ).OrderBy(Function(Contact) Contact.LastName)

        For Each contactItem In ergebnisListe
            Console.WriteLine(contactItem.ID & ": " & _
                        contactItem.LastName & ", " & _
                        contactItem.FirstName & " living in " & _
                        contactItem.City)

        Next
    End Sub

    Public Sub KombinierteErweiterungsmethoden_á_la_LINQ()

        Dim ergebnisListe = From einKontakt In Kontakte _
                            Where einKontakt.Ort = "Lippstadt" _
                            Select ID = einKontakt.ID, _
                                    LastName = einKontakt.Nachname, _
                                    FirstName = einKontakt.Vorname, _
                                    City = einKontakt.Ort _
                            Order By LastName

        For Each contactItem In ergebnisListe
            Console.WriteLine(contactItem.ID & ": " & _
                        contactItem.LastName & ", " & _
                        contactItem.FirstName & " living in " & _
                        contactItem.City)

        Next

    End Sub

End Module
