﻿Imports System
Imports System.Collections.Generic
Imports System.Windows
Imports System.Windows.Media.Imaging
Imports System.IO

Namespace Betrachter
    Partial Public Class Window1
        Inherits System.Windows.Window

        Private strPfad As String
        Private data As New ArrayList
        Private iPos As Integer = 0

        Public Sub New()
            InitializeComponent()
            strPfad = Environment.GetFolderPath _
            (Environment.SpecialFolder.MyPictures)
            BeginnDarstellung()
        End Sub

        Private Sub BeginnDarstellung()
            data.Clear()
            iPos = 0

            Try
                Dim di As DirectoryInfo = New DirectoryInfo(strPfad)
                For Each fi As FileInfo In di.GetFiles("*.jpg")
                    data.Add(fi.FullName)
                Next
                If data.Count > 0 Then
                    img.Source = New BitmapImage _
                    (New Uri(CStr(data.Item(0)), UriKind.Absolute))
                End If
            Catch ex As Exception
                MessageBox.Show("Fehler: " & ex.Message)
            End Try
        End Sub

        Private Sub OnPfad(ByVal sender As Object, _
                           ByVal e As RoutedEventArgs)
            Dim dlgPfad As New PfadDialog
            dlgPfad.PfadName = strPfad

            If dlgPfad.ShowDialog = True Then
                If Not String.IsNullOrEmpty(dlgPfad.PfadName) Then
                    strPfad = dlgPfad.PfadName
                    BeginnDarstellung()
                End If
            End If
        End Sub

        Private Sub OnErstes(ByVal sender As Object, _
                             ByVal e As RoutedEventArgs)
            If data.Count > 0 Then
                iPos = 0
                img.Source = New BitmapImage _
                (New Uri(CStr(data.Item(iPos)), UriKind.Absolute))
            End If
        End Sub

        Private Sub OnZurueck(ByVal sender As Object, _
                              ByVal e As RoutedEventArgs)
            If iPos > 0 Then
                iPos -= 1
                img.Source = New BitmapImage _
                (New Uri(CStr(data.Item(iPos)), UriKind.Absolute))
            End If
        End Sub

        Private Sub OnWeiter(ByVal sender As Object, _
                             ByVal e As RoutedEventArgs)
            If iPos + 1 < data.Count Then
                iPos += 1
                img.Source = New BitmapImage _
                (New Uri(CStr(data.Item(iPos)), UriKind.Absolute))
            End If
        End Sub

        Private Sub OnLetztes(ByVal sender As Object, _
                             ByVal e As RoutedEventArgs)
            If data.Count > 0 Then
                iPos = data.Count - 1
                img.Source = New BitmapImage _
                (New Uri(CStr(data.Item(iPos)), UriKind.Absolute))
            End If
        End Sub

        Private Sub OnBeenden(ByVal sender As Object, _
                              ByVal e As RoutedEventArgs)
            Me.Close()
        End Sub
    End Class
End Namespace
