﻿Imports System
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Shapes

Namespace Bezier2
    Partial Public Class Window1
        Const cRad As Integer = 8
        Dim f As PathFigure
        Dim bs As BezierSegment

        Public Sub New()
            InitializeComponent()

            ' Geometrie holen und die vier Punkte 
            ' ermitteln und darstellen

            Dim geo As PathGeometry = _
            CType(bezier.Data, PathGeometry)
            f = geo.Figures.Item(0)
            DefinePoint("e0", f.StartPoint)
            bs = CType(f.Segments.Item(0), BezierSegment)
            DefinePoint("e1", bs.Point1)
            DefinePoint("e2", bs.Point2)
            DefinePoint("e3", bs.Point3)
        End Sub

        Private Sub DefinePoint(ByVal strName As String, _
                                ByVal pt As Point)
            ' Ellipsenelement darstellen
            Dim ell As New Ellipse
            ell.Name = strName
            ell.Width = cRad * 2
            ell.Height = cRad * 2
            ell.Stroke = Brushes.Black
            ell.Fill = Brushes.Red
            ' Position im Canvas-Element setzen
            ell.SetValue(Canvas.LeftProperty, pt.X - cRad)
            ell.SetValue(Canvas.TopProperty, pt.Y - cRad)
            ' Erforderliche Ereignismethoden
            AddHandler ell.MouseLeftButtonDown, _
            New MouseButtonEventHandler(AddressOf Me.MouseLeftButtonDown)
            AddHandler ell.MouseLeftButtonUp, _
            New MouseButtonEventHandler(AddressOf Me.MouseLeftButtonUp)
            AddHandler ell.MouseMove, _
            New MouseEventHandler(AddressOf Me.MouseMove)
            ' Ellipse in den Container (Canvas-Element) einfügen
            Me.cont.Children.Add(ell)

        End Sub

        Private Sub MouseLeftButtonDown(ByVal sender As Object, _
                                        ByVal e As MouseEventArgs)
            Dim ell As Ellipse = TryCast(sender, Ellipse)
            ' Click-Position relativ zum Canvas-Element ermitteln
            Dim pt As Point = e.GetPosition(Me.cont)
            ' Maus-Ereigins auch von außerhalb des Fensters
            ell.CaptureMouse()
            ' Neue Position der Ellipse setzen
            Me.SetNewPoint(ell, pt)
        End Sub

        Private Sub MouseLeftButtonUp(ByVal sender As Object, _
                                      ByVal e As MouseEventArgs)
            Dim ell As Ellipse = TryCast(sender, Ellipse)
            Dim pt As Point = e.GetPosition(Me.cont)
            ' Wenn Maus außerhalb des Fensters, dann den Punkt in die Mitte des Fensters legen
            If ((((pt.X < 0) OrElse (pt.Y < 0)) OrElse (pt.X > Me.cont.ActualWidth)) OrElse (pt.Y > Me.cont.ActualHeight)) Then
                pt = New Point((Me.cont.ActualWidth / 2), (Me.cont.ActualHeight / 2))
            End If
            ' Maus-Ereignisse wieder mormal verarbeiten
            ell.ReleaseMouseCapture()
            ' Neue Position der Ellipse setzen
            Me.SetNewPoint(ell, pt)
        End Sub

        Private Sub MouseMove(ByVal sender As Object, _
                              ByVal e As MouseEventArgs)
            If (e.LeftButton = MouseButtonState.Pressed) Then
                Dim ell As Ellipse = TryCast(sender, Ellipse)
                ' Click-Position relativ zum Canvas-Element ermitteln
                Dim pt As Point = e.GetPosition(Me.cont)
                ' Neue Position der Ellipse setzen
                Me.SetNewPoint(ell, pt)
            End If
        End Sub

        Private Sub SetNewPoint(ByVal ell As Ellipse, _
                                ByVal pt As Point)
            ell.SetValue(Canvas.LeftProperty, (pt.X - 8))
            ell.SetValue(Canvas.TopProperty, (pt.Y - 8))

            ' Je nach Namen der Ellipse, Startpunkt 
            'oder Kontrollpunkte im Bezier-Segment setzen
            If (ell.Name = "e0") Then
                Me.f.StartPoint = pt
            ElseIf (ell.Name = "e1") Then
                Me.bs.Point1 = pt
            ElseIf (ell.Name = "e2") Then
                Me.bs.Point2 = pt
            ElseIf (ell.Name = "e3") Then
                Me.bs.Point3 = pt
            End If
        End Sub
    End Class
End Namespace

