﻿Imports System
Imports System.Windows
Imports System.Windows.Controls

Namespace CircPanel
    Partial Public Class Window1
        Inherits System.Windows.Window

        Dim c As New CirclePanel
        Public Sub New()
            InitializeComponent()
            For i As Integer = 0 To 7
                Dim b As New Button
                b.Content = "Test " + i.ToString
                c.Children.Add(b)
            Next

            Me.Content = c
        End Sub
    End Class

    Public Class CirclePanel
        Inherits System.Windows.Controls.Panel

        Private dDurchmesser As Double
        Private iCount As Integer
        Private dPhi As Double
        Dim dMaxWidth As Double
        Dim dMaxHeight As Double

        Protected Overrides Function MeasureOverride _
        (ByVal availableSize As Size) As Size

            ' Alle Kindelemente bekommen die gleiche Größe und
            'zwar die des größten Elements
            dMaxWidth = 0.0
            dMaxHeight = 0.0
            iCount = 0

            For Each Child As UIElement In Me.Children

                ' Größe ermitteln
                Child.Measure(New Size(Double.PositiveInfinity, Double.PositiveInfinity))
                Dim childSize As Size = Child.DesiredSize

                ' Größte Breite und Höhe ermitteln
                If childSize.Height > dMaxHeight Then
                    dMaxHeight = childSize.Height
                End If

                If childSize.Width > dMaxWidth Then
                    dMaxWidth = childSize.Width
                End If

                ' Anzahl ermitteln
                iCount += 1
            Next

            ' Winkel für jedes Element auf dem Kreis ermitteln
            dPhi = 2.0 * Math.PI / iCount

            ' Durchmesser des Kreises ermitteln
            dDurchmesser = dMaxWidth / (Math.Sin(dPhi / 2.0))

            ' Durchmesser um max. Höhe der Elemente erweitern
            ' Kreis liegt jeweils auf den Zentren des Buttons
            dDurchmesser += dMaxHeight

            ' Gewünschte Größe zurückgeben
            Return New Size(dDurchmesser, dDurchmesser)

        End Function

        Protected Overrides Function ArrangeOverride(ByVal finalSize As Size) As Size
            ' An den vorgegebenen Bereich des Layout-Systems anpasen
            dDurchmesser = Math.Min(finalSize.Width, finalSize.Height) - dMaxWidth

            ' Achtung: Durchmesser kleiner Null nicht erlaubt
            If dDurchmesser < 0.0 Then
                dDurchmesser = 0.0
            End If

            Dim pos As New Point
            Dim dWinkel As Double = 0.0

            ' Positionierung aller Elemente auf dem Kreis
            ' Die Mittelpunkte der Kindelemente lieben auf dem Kreis
            For Each child As UIElement In Me.Children

                ' Die Position berechnen...
                pos.X = (dDurchmesser / 2.0) * Math.Sin(dWinkel) _
                + dDurchmesser / 2.0 - dMaxWidth / 2.0
                pos.Y = -(dDurchmesser / 2.0) * Math.Cos(dWinkel) _
                + dDurchmesser / 2.0 - dMaxHeight / 2.0

                ' position dem layout-System mitteilen
                Dim childRect As New Rect
                childRect = New Rect(pos, New Size(dMaxWidth, dMaxHeight))
                child.Arrange(childRect)

                dWinkel += dPhi
            Next

            ' Endgültige Größe zurückgeben
            Return New Size(dDurchmesser, dDurchmesser)
        End Function
    End Class
End Namespace