﻿Imports System
Imports System.Windows
Imports System.Windows.Input
Imports System.Windows.Media

Namespace HitTesting
    Partial Public Class Window1
        Inherits System.Windows.Window
        Public Sub New()
            InitializeComponent()
        End Sub

        Private Sub OnMouseDown(ByVal sender As Object, _
                                ByVal e As MouseEventArgs)
            ' Mausposition ermitteln
            Dim pt As Point = e.GetPosition(DirectCast(sender, UIElement))
            ' Fläche für Trefferbereich festlegen
            Dim newHitTestArea As EllipseGeometry = New EllipseGeometry(pt, 20.0, 20.0)
            ' Rückrufprozedur für einen Treffer einrichten
            VisualTreeHelper.HitTest(path, Nothing, _
                                     New HitTestResultCallback(AddressOf HitResult), _
                                     New GeometryHitTestParameters(newHitTestArea))
        End Sub

        Public Function HitResult(ByVal result As HitTestResult) As HitTestResultBehavior

            ' Ermitteln des Hit-Test-Ergebnisses
            Select Case DirectCast(result, GeometryHitTestResult).IntersectionDetail
                Case IntersectionDetail.FullyInside
                    MessageBox.Show("Vollst" & ChrW(228) & "ndig innen!")
                    Return HitTestResultBehavior.Continue
                Case IntersectionDetail.FullyContains
                    MessageBox.Show("Voll getroffen!")
                    Return HitTestResultBehavior.Stop
                Case IntersectionDetail.Intersects
                    MessageBox.Show("Teilweise getroffen!")
                    Return HitTestResultBehavior.Continue
            End Select
            Return HitTestResultBehavior.Stop
        End Function
    End Class
End Namespace